extern int chkpassword(char *, char *);

typedef struct
{
	int (* chkpasswd)(void *, char *, char **errmsg); 
	char *(* gethomedir)(void *);
	char *(* getrootdir)(void *);
	uid_t (* getuseruid)(void *);
	gid_t (* getusergid)(void *);
	void *(* gethandle)(char *username, char *params);
	void (* freehandle)(void *);
} PERMSTRUCT;

extern PERMSTRUCT unixauth_commands;
extern PERMSTRUCT anonauth_commands;
extern PERMSTRUCT internalauth_commands;
extern PERMSTRUCT disableauth_commands;

#ifdef MUDAUTH
extern PERMSTRUCT mudauth_commands;
#endif

#ifdef HAVE_PAM_START
extern PERMSTRUCT pamauth_commands;
#endif

typedef struct
{
	char *authname;
	PERMSTRUCT *authstruct;
} PERMINFO;
