/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"
#include "auth.h"

/* This file contains code to autheticate for anonymous users */

typedef struct 
{
	struct passwd *passent;
} PASSWDSTRUCT;

void *anonauth_gethandle(char *username, char *params)
{
	PASSWDSTRUCT *newhandle;
	
	newhandle = mallocwrapper(sizeof(PASSWDSTRUCT));
	
	if (params == NULL)
		params = "ftp";
	
	newhandle->passent = getpwnam(params);
	if (newhandle->passent == NULL)
		goto error;
	
	return(newhandle);

error:
	freewrapper(newhandle);
	return(NULL);
}

void anonauth_freehandle(void *handle)
{
	freewrapper(handle);
}

int anonauth_checkpasswd(void *h, char *password, char **errmsg)
{
	return(TRUE);
}

char *anonauth_getrootdir(void *h)
{
	return(((PASSWDSTRUCT *)h)->passent->pw_dir);
}

char *anonauth_gethomedir(void *h)
{
	return("/");
}

uid_t anonauth_getuseruid(void *h)
{
	return(((PASSWDSTRUCT *)h)->passent->pw_uid);
}

gid_t anonauth_getusergid(void *h)
{
	return(((PASSWDSTRUCT *)h)->passent->pw_gid);
}

PERMSTRUCT anonauth_commands =
{
	anonauth_checkpasswd,
	anonauth_gethomedir,
	anonauth_getrootdir,
	anonauth_getuseruid,
	anonauth_getusergid,
	anonauth_gethandle,
	anonauth_freehandle,
};
