/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

extern int signumber;

int popcmd(FTPSTATE *peer, char **outstr)
{
	/* find the EOL marker (remember it is in ansi style!) */
	char *chtmp = strstr(peer->inbuffer, "\xD\n"); 
	
	if (chtmp == NULL)
		return(FALSE);
	else
	{
		*chtmp = 0;
		*outstr = strdupwrapper(peer->inbuffer);
		chtmp += 2;	/* increment chtmp by two */
		memmove(peer->inbuffer, chtmp, strlen(chtmp)+1);
		return(TRUE);
	}
}
	
int readcmd(FTPSTATE *peer)
{
	int exits = FALSE;
	int buflen = strlen(peer->inbuffer);
	int stringlen;
	
	if (buflen + BUFFERSIZE > peer->inbuffersize)
 	{
 		peer->inbuffersize = buflen + BUFFERSIZE * 2 - 1;
 		if (peer->inbuffersize > MAXMSGLEN)
		{
			ftp_write(peer, 500, "You are flooding me, begone!");
			return(TRUE);
		}
 		reallocwrapper(buflen + BUFFERSIZE * 2, (void *)&(peer->inbuffer));
	}
	
	stringlen = read(peer->remotefd, &(peer->inbuffer[buflen]), BUFFERSIZE) + buflen; 
 	
#ifdef DEBUG
	printf("[readcmd user: %s]\n", peer->username);
#endif	
 	if (stringlen == buflen)  /* means fd is closed */
 		exits = TRUE;
 	else
 		peer->inbuffer[stringlen] = 0;

#ifdef DEBUG
	printf("[readcmd done user %s]\n", peer->username);
#endif
	return(exits);	
}
