/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

void dir_tovirtual(FTPSTATE *peer, char *normaldir)
{
	int a = strlen(peer->basedir);
	int b = strlen(normaldir);
	
	memmove(normaldir, &(normaldir[a]), b - a);
	normaldir[b-a] = 0;
	if (strcmp(normaldir, "") == 0)
	{
		strcpy(normaldir, "/");
	}
}

void dir_toreal(FTPSTATE *peer, char *virdir)
{
	char *tmp = strdupwrapper(virdir);
	
	if (strcmp(tmp, "/") == 0)
	{
 		tmp[0] = 0;
	}

	sprintf(virdir, "%s%s", peer->basedir, tmp);
	freewrapper(tmp);
}

void dir_combine(FTPSTATE *peer, char **pwd, char *newdir)
{
	char *virdir; 
	char *tmp;
	int a = strlen(newdir);
	char *newdircpy = mallocwrapper(a+3);
	char *ndc2 = newdircpy;

	strcpy(newdircpy, newdir);
	
	/* adjust the size of the pwd so combining will fit */
	reallocwrapper(a + strlen(*pwd) + strlen(peer->homedir) + 3, (void *)pwd);
	
	virdir = (*pwd + strlen(peer->basedir)); 
	
	newdircpy[a] = '/';
	newdircpy[a+1] = 0;		/* make sure it ends with a / */

	if (newdircpy[0] == '/')
	{
		strcpy(virdir, "");
		newdircpy++;
	}
	else if (newdircpy[0] == '~')
	{
		strcpy(virdir, peer->homedir);
		newdircpy++;
	}
		
	tmp = strchr(newdircpy, '/');
	while (tmp != NULL)
	{
		*tmp = 0;
		if (strcmp(newdircpy, ".") == 0);	/* do nothing */
		else if (strcmp(newdircpy, "") == 0); /* do nothing */
		else if (strcmp(newdircpy, "..") == 0)
		{
			char *tmp2 = strrchr(virdir, '/');
			
			if (tmp2 != NULL)
				*tmp2 = 0;
		}
		else
		{
			strcat(virdir, "/");
			strcat(virdir, newdircpy);
		}	

		newdircpy = tmp+1;
		tmp = strchr(newdircpy, '/');
	}
	freewrapper(ndc2);
}
