/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

/* Sends a message to the screen and then returns to the program */

void errormsg( char *errmessage, char *file, int line )
{
	fprintf(stderr, PROGNAME" error in file %s line %d: %s\n", file, line, errmessage);
}

/* Sends a message to the screen and exits gracefully */

void errormsgfatal( char *errmessage, char *file, int line )
{
	errormsg( errmessage, file, line );
	fprintf( stderr, "CANNOT RESUME. Goodbye\n");

	/* Shutdown */	
	shmem_finish();
#ifndef DEBUG
	exit(0);
#else
	abort();
#endif	
}
