/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

#define OUTBUFSIZE	1024

int ftp_write(FTPSTATE *peer, int messnum, char *fmt, ...)
{
	int error, quit = 0;
	va_list printfargs;
	char *outbuf = mallocwrapper(OUTBUFSIZE);
	char format[OUTBUFSIZE];
	
	/* prepare the format */
	snprintf(format, OUTBUFSIZE, "%d %s\xD\n", messnum, fmt);
	
	/* Make the output string */
	
	va_start(printfargs, fmt);
	error = vsnprintf(outbuf, OUTBUFSIZE, format, printfargs);
	va_end(printfargs);
		
	if (error == -1)
	{
		reallocwrapper(MAXMSGLEN, (void *)&outbuf);
		va_start(printfargs, fmt);
		error = vsnprintf(outbuf, MAXMSGLEN, format, printfargs);
		va_end(printfargs);
	}
	
	if (error == -1)	/* you shouldn't be able to generate a message
				   long enought for this to occur */
	{
		sprintf(outbuf, "521 Result message too long, good bye!\xD\n");
		quit = TRUE;
	}
	
	error = (-1 == write(peer->remotefd, outbuf, strlen(outbuf)));
 
 	if (quit)
 		close(peer->remotefd);
	/* Now log it too */
	
	outbuf[strlen(outbuf)- 2] = 0;
	log_addentry(MYLOG_RESPONSE, peer->remoteip, peer->username, outbuf);
	
	freewrapper(outbuf);
	return(error | quit);
}
