/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

void ftpstate_init(FTPSTATE *ftp, int fd, int ip, int threadnum, int portnum)
{
	ftp->remotefd = fd;
	ftp->remoteip = ip;
	ftp->threadnum = threadnum;
	ftp->connport = portnum;
	ftp->username = mallocwrapper(BUFFSMALL);
	strcpy(ftp->username, "<unknown>");

	ftp->pwd = NULL;
	ftp->homedir = NULL;
	ftp->renameoldname = NULL;
	
	ftp->loggedin = FALSE;
	ftp->restartpos = 0;
	ftp->binary = TRUE;
	ftp->remoteport = portnum - 1;
	ftp->passiveport = 0;
	
	ftp->basedir = NULL;
	
	ftp->logindump = NULL;

	ftp->inbuffer = mallocwrapper(BUFFERSIZE);
	ftp->inbuffersize = BUFFERSIZE;
	strclear(ftp->inbuffer);
	
	ftp->maxusers = config->maxthreads;
	ftp->maxtimeout = ftp->timeout = config->timeout;
	
	ftp->acldata = NULL;
	ftp->umask = config->umask;       /* set default umask */
	ftp->chmodable = FALSE;
	ftp->dport = NULL;
	ftp->cwddump = NULL;
	ftp->busydump = NULL;
	ftp->quitdump = NULL;
	ftp->loginsleft = config->logincount;
	ftp->jailenabled = FALSE;

	/* set session stats stuff! */
	ftp->downloadedfiles = 0;
	ftp->uploadedfiles = 0;
	ftp->downloadedfilebytes = 0;
	ftp->uploadedfilebytes = 0;
	ftp->listdownloadedbytes = 0;
	ftp->listconns = 0;
}

void ftpstate_dest(FTPSTATE *ftp)
{
	if (ftp->username) freewrapper(ftp->username);
	if (ftp->pwd) freewrapper(ftp->pwd);
	if (ftp->homedir) freewrapper(ftp->homedir);
	if (ftp->renameoldname) freewrapper(ftp->renameoldname);
	if (ftp->basedir) freewrapper(ftp->basedir);
	if (ftp->logindump) freewrapper(ftp->logindump);
	if (ftp->inbuffer) freewrapper(ftp->inbuffer);
	if (ftp->cwddump) freewrapper(ftp->cwddump);
	if (ftp->busydump) freewrapper(ftp->busydump);
	if (ftp->quitdump) freewrapper(ftp->quitdump);
	if (ftp->dport)
	{
		freewrapper(ftp->dport->buffer);
		freewrapper(ftp->dport);
	}
	freewrapper(ftp);
}
