/* Copyright (C) 1999 Beau Kuiper
   this is a quick hack for ftpwho. not really nice yet

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#define ERRORMSGFATAL(x)	{	printf("error %s. Exiting!\n", x); exit(1); 	}
#define NOSIGNALINTR(x)		(x)
#include <stdio.h>
#include <fcntl.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>
#include <errno.h>
#include <assert.h>
#include <unistd.h>

#include "pnums.h"
#include "shmem.h"
#include "config.h"

void shmem_connect(char *configfile)
{
	int shmemnum;
	void *shmemptr;
	key_t ipckey = ftok(configfile, '/');
	
#ifdef DEBUG
	printf("[shmat_init]\n");
#endif	
	shmemnum = shmget(ipckey, 1024 * SHMEMTOTAL, 0);
	if (shmemnum == -1)
	{
		printf("IPC: cannot find shared memory, reason: %s\n", strerror(errno));
		exit(1);
	}	

	shmemptr = shmat(shmemnum, NULL, 0600);
	if ((int)shmemdata == -1)
	{
		printf("IPC: fail to connect to shared memory, reason: %s\n", strerror(errno));
		exit(1);
	}	
		
	
	shmemdata = shmemptr;
	
	/* get semaphores. Using the config file so others can join in (we use file locks for portability, simplicity
	   and usability. */
	
	shmem_lockfd = open(configfile, O_RDWR);
	if (shmem_lockfd == -1)
		ERRORMSGFATAL(strerror(errno)); 
}

void pnums_info(void)
{
	THREADSTAT *pnums = (THREADSTAT *)((char *)shmemdata + sizeof(struct shmemctr));
	int count, numusers = 0;
	
	printf("DISPLAYING USER STATS\n");
	printf("--------------------------------------------------------------------\n");
	printf("Threadid   Username              IpAddress        PID    Operation  \n");
	printf("--------------------------------------------------------------------\n");
	for (count = 0; count < shmemdata->pnum_count; count++)
	{
		shmem_lock(count + 1);
		if (pnums[count].pid > 0)
		{
			unsigned int ip = pnums[count].remoteip;
			printf("%8d   %-20s  %d.%d.%d.%d        %d %s\n", count,
				pnums[count].username, ip >> 24,
				(ip >> 16) & 255, (ip >> 8) & 255, ip & 255,
				pnums[count].pid, pnums[count].currentop);
			numusers++;
		}
		shmem_unlock(count + 1);
	}
	printf("---- %4d users of %4d maximum ------------------------------------\n", numusers, shmemdata->pnum_count);
}

int main(int argc, char **argv)
{
	if (argc > 1)
		shmem_connect(argv[1]);
	else
		shmem_connect(CONFIGFILE);
	pnums_info();
/*	shmem_stats(); */
	return(0);
}
