/* Copyright (C) 1999 Beau Kuiper

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "ftpd.h"

STRCACHE *strcache_new(void)
{
	STRCACHE *cache = mallocwrapper(sizeof(STRCACHE));
	
	memset(cache, 0, sizeof(STRCACHE));
	return(cache);
}	

char *strcache_check(STRCACHE *cache, int num)
{
	int counter = 0;
	
	while (counter < cache->size)
	{
		if (cache->data[counter].num == num)
			return(cache->data[counter].str);
		counter++;
	}
	
	return(NULL);
}

void strcache_add(STRCACHE *cache, int num, char *str)
{
	if (cache->size < STRCACHESIZE)
	{
		cache->data[cache->size].num = num;
		cache->data[cache->size].str = strdupwrapper(str);
		(cache->size)++;
	}
}

void strcache_free(STRCACHE *cache)
{
	int counter = 0;
	
	while (counter < cache->size)
	{
		freewrapper(cache->data[counter].str);
		counter++;
	}
	freewrapper(cache);
}
